# pylint: disable=C0301
"""
RASCIL
-------------------------

Context
~~~~~~~~~~~~~~~~~~~~~~~~

The Radio Astronomy Simulation, Calibration and Imaging Library expresses radio interferometry
calibration and imaging algorithms in python and numpy. The interfaces all operate with familiar
data structures such as image, visibility table, gain table, *etc*. The source code is hosted on
SKA `GitLab <https://gitlab.com/ska-telescope/external/rascil>`__ repository and documentation can
be found `here <https://ska-telescope.gitlab.io/external/rascil/>`__.

Test parameterisation
~~~~~~~~~~~~~~~~~~~~~~~~

Currently, the benchmark supports three different parameterisations namely,
- Number of nodes
- Size of benchmark

Size of the benchmark defines how big of the benchmark we would want to run. In this case, size
refers to number of frequency channels we are going to use to make the continuum image. Finally,
scalability of the test can be specified using number of nodes. They are defined in the ReFrame
test as follows:

.. code-block:: python

  size = parameter(['small', 'large', 'very-large', 'huge'])
  num_nodes = parameter(1 << i for i in range(int(min), int(max)))
  

Environment variables
~~~~~~~~~~~~~~~~~~~~~~~~

By default, the variables ``min`` and ``max`` are defined as 3 and 7, respectively. So, this
parameterisation creates tests with number of nodes ranging from 8 to 64 in multiples of 2. The
user can override the ``min`` and ``max`` variables using custom test environment variables
``RASCILTEST_MIN`` and ``RASCILTEST_MAX``, respectively. If any of these environment variables
are set, they will take precedence over default values. All these parameterisations are provided
as tags to the ReFrame tests and hence, we can simply choose which benchmark we want to run by
specifying appropriate tags on command line.

By default, the test will create a ``conda`` environment and run inside it for the 
sake of isolation. This can be controlled using env variable ``CREATE_CONDA_ENV``. 
By setting it to ``NO``, the test WILL NOT create ``conda`` environment.

Similarly, the performance metrics are monitored using the `perfmon <https://gitlab.com/ska-telescope/sdp/ska-sdp-perfmon>`_ toolkit. If
the user does not want to monitor metrics, it can be achieved by setting 
``MONITOR_METRICS=NO``. 


Usage
~~~~~~~~~~~~~~~~~~~~~~~~

The tests can be run using the following commands:

.. code-block:: bash

  cd ska-sdp-benchmark-tests
  conda activate ska-sdp-benchmark-tests
  reframe/bin/reframe -C reframe_config.py -c apps/level2/rascil/reframe_rascil.py --run --performance-report

But first let's see the tests generated by ReFrame using ``--list`` command as follows:

.. code-block:: bash

  cd ska-sdp-benchmark-tests
  conda activate ska-sdp-benchmark-tests
  reframe/bin/reframe -C reframe_config.py -c apps/level2/rascil/reframe_rascil.py --list

The output is shown below:

.. code-block:: bash

  [ReFrame Setup]
  version:           3.8.0-dev.2+8a9ceeda
  command:           'reframe/bin/reframe -C reframe_config.py -c apps/level2/rascil/reframe_rascil.py -l'
  launched by:       mpaipuri@fnancy
  working directory: '/home/mpaipuri/ska-sdp-benchmark-tests'
  settings file:     'reframe_config.py'
  check search path: (R) '/home/mpaipuri/ska-sdp-benchmark-tests/apps/level2/rascil/reframe_rascil.py'
  stage directory:   '/home/mpaipuri/ska-sdp-benchmark-tests/stage'
  output directory:  '/home/mpaipuri/ska-sdp-benchmark-tests/output'

  [List of matched checks]
  - RascilTest_small_100 (found in '/home/mpaipuri/ska-sdp-benchmark-tests/apps/level2/rascil/reframe_rascil.py')
  - RascilTest_large_16 (found in '/home/mpaipuri/ska-sdp-benchmark-tests/apps/level2/rascil/reframe_rascil.py')
  - RascilTest_large_50 (found in '/home/mpaipuri/ska-sdp-benchmark-tests/apps/level2/rascil/reframe_rascil.py')
  - RascilTest_large_100 (found in '/home/mpaipuri/ska-sdp-benchmark-tests/apps/level2/rascil/reframe_rascil.py')
  - RascilAndDatasetDownloadTest (found in '/home/mpaipuri/ska-sdp-benchmark-tests/apps/level2/rascil/reframe_rascil.py')
  - RascilTest_small_25 (found in '/home/mpaipuri/ska-sdp-benchmark-tests/apps/level2/rascil/reframe_rascil.py')
  - RascilTest_large_25 (found in '/home/mpaipuri/ska-sdp-benchmark-tests/apps/level2/rascil/reframe_rascil.py')
  - RascilTest_large_8 (found in '/home/mpaipuri/ska-sdp-benchmark-tests/apps/level2/rascil/reframe_rascil.py')
  - RascilTest_small_16 (found in '/home/mpaipuri/ska-sdp-benchmark-tests/apps/level2/rascil/reframe_rascil.py')
  - RascilTest_small_50 (found in '/home/mpaipuri/ska-sdp-benchmark-tests/apps/level2/rascil/reframe_rascil.py')
  - RascilTest_small_8 (found in '/home/mpaipuri/ska-sdp-benchmark-tests/apps/level2/rascil/reframe_rascil.py')
  - RascilBuildTest (found in '/home/mpaipuri/ska-sdp-benchmark-tests/apps/level2/rascil/reframe_rascil.py')
  Found 12 check(s)

  Log file(s) saved in '/home/mpaipuri/ska-sdp-benchmark-tests/reframe.log', '/home/mpaipuri/ska-sdp-benchmark-tests/reframe.out'

As we can see, there are a lot of 12 tests generated by ReFrame and they are for a given system
partition. If we defined multiple partitions and environments, number of tests will be multiplied
by number of partitions and environments.

For example, if we want to run ``small`` test with 8 nodes, following commands must be used

.. code-block:: bash

  cd ska-sdp-benchmark-tests
  conda activate ska-sdp-benchmark-tests
  reframe/bin/reframe -C reframe_config.py -c aapps/level2/rascil/reframe_rascil.py --tag dry-test --tag 8$ --tag small --run --performance-report

Test class documentation
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
"""
# pylint: enable=C0301

import os
from datetime import datetime

import reframe as rfm
from modules.base_class import RunOnlyBenchmarkBase
from reframe.core.backends import getlauncher  # pylint: disable=import-error
import reframe.utility.osext as osext  # pylint: disable=import-error
import reframe.utility.sanity as sn   # pylint: disable=import-error
from reframe.core.builtins import run_after, run_before, fixture, parameter, variable, require_deps, \
    performance_function
from reframe.core.deferrable import deferrable
from reframe.utility import udeps  # pylint: disable=import-error
import reframe.utility.typecheck as typ  # pylint: disable=import-error

from modules.reframe_extras import AppBase
from modules.reframe_extras import FetchSourcesBase

from modules.utils import filter_systems_by_env, emit_conda_activate_cmds

# pylint: disable=C0116,E0401,E0602,E1101,W0201

# Global variables
GCP_URL = 'gs://ska1-simulation-data/simulations/continuum_simulations_SP-1331/mid'
DATASET_NAME = 'SKA_MID_SIM_custom_B2_dec_-45.0_nominal_nchan100'

# Define varibales that will be shared across tests here
# Each test will run in its own conda environment. We define name of that environment here
CONDA_ENV_NAME = 'rfm_RascilTest'


class RascilAndDatasetDownloadTest(FetchSourcesBase):
    """Fetch RASCIL sources and datasets"""

    descr = ('Fetch RASCIL source code and download measurement '
             'datasets from Google cloud')
    # sourcesdir = 'https://gitlab.com/ska-telescope/external/rascil.git'
    sourcesdir = 'https://gitlab.com/ska-telescope/external/rascil-main.git'
    cnd_env_name = CONDA_ENV_NAME

    @run_after('setup')
    def download_dataset(self):
        """Download dataset using subprocess command"""
        dataset_file = DATASET_NAME + '.ms'
        download_path = os.path.join(self.prefix, 'datasets')
        dataset_path = os.path.join(download_path, dataset_file)
        self.returncode = 0  # In case download is not needed
        if not os.path.exists(dataset_path):
            os.makedirs(download_path, exist_ok=True)
            cmd = f'gsutil -m cp -r \"{GCP_URL}/{dataset_file}/\" {download_path}'
            completed_process = osext.run_command(cmd=cmd, check=True)
            self.returncode = completed_process.returncode

    @run_before('sanity')
    def set_sanity_patterns(self):
        """Set sanity patterns"""
        self.sanity_patterns = sn.all([
            sn.assert_not_found('error', self.stderr),
            sn.assert_eq(0, self.returncode),
        ])


@rfm.simple_test
class RascilBuildTest(RunOnlyBenchmarkBase):
    """RASCIL build test"""

    descr = 'Install RASCIL from sources'

    # Share resource from fixture
    rascil_src = fixture(RascilAndDatasetDownloadTest, scope='session')

    def __init__(self):
        super().__init__()
        self.valid_prog_environs = [
            'rascil',
        ]
        self.valid_systems = filter_systems_by_env(self.valid_prog_environs)
        self.maintainers = [
            'Mahendra Paipuri (mahendra.paipuri@inria.fr)'
        ]
        # Cross compilation is not possible on certain g5k clusters. We force
        # the job to be non-local so building will be on remote node
        if 'g5k' in self.current_system.name:
            self.local = False
        else:
            self.local = True

        if os.getenv('CREATE_CONDA_ENV', 'YES') == 'YES':
            self.prerun_cmds = emit_conda_activate_cmds(CONDA_ENV_NAME)

    @run_after('setup')
    def set_sourcedir(self):
        """Set source directory from dependencies"""
        self.sourcesdir = self.rascil_src.stagedir

    @run_after('setup')
    def set_env_variables(self):
        """Set env variables"""
        self.variables = {
            'MPICC': '$OPENMPI_ROOT/bin/mpicc',  # mpi4py needs this var
        }

    @run_before('run')
    def pre_launch(self):
        """Install dependencies of RASCIL before installing RASCIL"""
        self.prerun_cmds += [
            'export PYTHONPATH=',  # temporarily clear PYTHONPATH so all dependencies will be installed within env
            'export CMAKE_ARGS="-DCUDA_ARCH=6.0"',
            'git-lfs pull',
            'pip install --no-cache-dir numpy==1.20.3',
            'git clone --depth 1 https://github.com/lofar-astron/PyBDSF.git',
            'cd PyBDSF && python setup.py install && cd ..',
            'pip install --no-cache-dir -r requirements.txt',
            'pip install --no-cache-dir mpi4py',
            'git clone --depth 1 --branch 2021.11.0 https://github.com/dask/dask-mpi.git',
            'cd dask-mpi && python setup.py install && cd ..',
            'pip install --no-cache-dir numba==0.53',  # downgrade numba to 0.53
        ]

    @run_before('run')
    def set_launcher(self):
        """Set launcher to local to avoid appending mpirun or srun to python command"""
        self.job.launcher = getlauncher('local')()

    @run_before('run')
    def set_executable(self):
        """Set executable as python to install RASCIL using setup.py"""
        #self.executable = 'python3'
        #self.executable_opts = ['setup.py', 'install']
        self.executable = 'python3'
        self.executable_opts = ['-m',
                                'pip',
                                'install',
                                '--index-url=https://artefact.skao.int/repository/pypi-all/simple',
                                'rascil']

    @run_before('sanity')
    def set_sanity_patterns(self):
        """Set sanity patterns"""
        self.sanity_patterns = sn.all([
            sn.assert_not_found('error: Command', self.stderr),
            #sn.assert_found('Finished processing dependencies for rascil',
            #                self.stdout),
            sn.assert_found('Successfully installed ', self.stdout),
        ])


@rfm.simple_test
class RascilTest(AppBase):
    """Main class of RASCIL runtime tests"""

    descr = 'RASCIL benchmark tests with DASK support.'

    # Parameterised tests
    #size = parameter(['small', 'large', 'very-large', 'huge', 'humongous'])
    size = parameter(['small'])

    # Variables to define min and max exponents of 2 to define number of nodes
    min_expnt = variable(int, value=int(os.getenv('RASCILTEST_MIN', 3)))
    max_expnt = variable(int, value=int(os.getenv('RASCILTEST_MAX', 7)))

    # Parameterise number of nodes
    num_nodes = parameter(1 << i for i in range(int(min_expnt), int(max_expnt)))

    # Benchmark configuration parameters for dask.
    dask_config = variable(dict, value={
        'nprocs': 1,  # per each node
        'nthreads': 1,
    })

    # Benchmark configuration
    benchmark = variable(dict, value={
        # We override the number of frequency channels based on number of nodes
        'small': {
            'image': 2048,
            'nmoment': 1,
            'nfreq_chan': 8,
            'nblock_vis': 1,
            'num_major_cycles': 5,
            'num_minor_cycles': 100,
        },
        'large': {
            'image': 4096,
            'nmoment': 3,
            'nfreq_chan': 100,
            'nblock_vis': 1,
            'num_major_cycles': 10,
            'num_minor_cycles': 10000,
        },
        'very-large': {
            'image': 8192,
            'nmoment': 3,
            'nfreq_chan': 100,
            'nblock_vis': 1,
            'num_major_cycles': 10,
            'num_minor_cycles': 10000,
        },
        'huge': {
            'image': 16384,
            'nmoment': 3,
            'nfreq_chan': 100,
            'nblock_vis': 1,
            'num_major_cycles': 10,
            'num_minor_cycles': 10000,
        },
        'humongous': {
            'image': 65536,
            'nmoment': 3,
            'nfreq_chan': 100,
            'nblock_vis': 1,
            'num_major_cycles': 10,
            'num_minor_cycles': 10000,
        },
    })

    def __init__(self):
        super().__init__()
        self.valid_prog_environs = [
            'rascil',
        ]
        self.valid_systems = filter_systems_by_env(self.valid_prog_environs)
        self.maintainers = [
            'Mahendra Paipuri (mahendra.paipuri@inria.fr)'
        ]
        self.exclusive_access = True
        if os.getenv('CREATE_CONDA_ENV', 'YES') == 'YES':
            self.prerun_cmds = emit_conda_activate_cmds(CONDA_ENV_NAME)

    @deferrable
    def convert_datestring_timestamp(self, time_str, fmt):
        """Convert date string to time stamp

        :param time_str: Date time string
        :type time_str: str
        :param fmt: Format of date time string
        :type fmt: str
        :returns: Time stamp of the date time string
        :rtype: str
        """
        
        # Remove null characters if any. Out files on NFS mounted drives tend to get null characters
        time_str = time_str.replace('\x00', '')
        if fmt == 'iso':
            return datetime.timestamp(datetime.fromisoformat(time_str))
        else:
            return datetime.timestamp(datetime.strptime(time_str, fmt))

    @run_after('init')
    def set_tags(self):
        """Add tags to the test"""
        self.tags |= {
            f'size={self.size}',
            f'num_nodes={self.num_nodes}',
            self.size, str(self.num_nodes),
        }
        
    @run_after('init')
    def set_dependencies(self):
        """Set dependencies of the test"""
        self.depends_on('RascilBuildTest', udeps.by_part)

    @require_deps
    def set_executable(self, RascilBuildTest):
        """Set executable path from dependencies"""
        self.sourcesdir = RascilBuildTest().stagedir
        self.executable_path = os.path.join(
            self.sourcesdir, 'rascil', 'apps', 'rascil_imager.py'
        )
        self.executable = 'python3'

    @run_after('setup')
    def skip_tests(self):
        """Skip test based on rules defined"""
        self.skip_if(
            self.num_nodes > 8 and self.size == 'small',
            msg="Small test case is only meant to run on 8 nodes or less"
        )

    @run_after('setup')
    def set_num_tasks_job(self):
        """Set number of MPI tasks of the job"""
        self.num_tasks_per_node_job = self.dask_config['nprocs']
        self.num_tasks_job = self.num_nodes * self.num_tasks_per_node_job
        self.tags |= {
            f'num_procs={self.num_tasks_job}'
        }

    @run_after('setup')
    def set_env_variables(self):
        """Set OpenMP threads and related environment variables"""
        self.num_threads = (self.current_partition.processor.num_cpus 
                            // self.current_partition.processor.num_cpus_per_core)
        self.variables = {
            'OMP_NUM_THREADS': str(self.num_threads),
            'RASCIL': self.sourcesdir,
            'RASCIL_DATA': os.path.join(self.sourcesdir, 'data'),
            'MALLOC_TRIM_THRESHOLD_': str(0),
            'RESULTS_DIR': self.stagedir,
            'SCHEDULER_FILE': os.path.join(
                self.stagedir, f"${self.scheduler_env_vars['job_id']}.dasksche.json"
            ),
        }

    @run_after('setup')
    def set_nfreq_channels(self):
        """Set number of frequency channels based on number of nodes"""
        self.benchmark[self.size]['nfreq_chan'] = self.num_nodes

    @run_after('setup')
    def set_launcher(self):
        """Set launcher to local to avoid appending mpirun or srun to python command"""
        self.job.launcher = getlauncher('local')()

    @run_after('setup')
    def setup_dask_launcher_cmd(self):
        """Setup dask launcher command"""
        nprocs = self.num_tasks_job + 1
        if self.launcher_name == 'mpirun':
            self.dask_launcher_cmd = f'mpirun --map-by node -np {nprocs} '
        elif self.launcher_name == 'mpiexec':
            self.dask_launcher_cmd = f'mpiexec -genvall -ppn 1 -n {nprocs} '
        elif self.launcher_name == 'srun':
            self.dask_launcher_cmd = (f'srun --ntasks-per-node 1 --ntasks {nprocs} '
                                      f'--cpus-per-task {self.num_threads} ')

    @run_after('setup')
    def symlink_dataset(self):
        """Symlink dataset from prefix to stagedir"""
        src = os.path.join(self.prefix, 'datasets', DATASET_NAME + '.ms')
        dest = os.path.join(self.stagedir, DATASET_NAME + '.ms')
        # Create symlink
        os.symlink(src, dest)

    @run_after('setup')
    def set_executable_opts(self):
        """Set RASCIL executable options"""
        self.executable_opts = [
            self.executable_path,
            f"--clean_nmoment {self.benchmark[self.size]['nmoment']}",
            '--clean_facets 8', '--clean_overlap 32',
            f"--clean_nmajor {self.benchmark[self.size]['num_major_cycles']}",
            '--clean_threshold 1e-5',
            '--clean_fractional_threshold 0.3',
            '--clean_restore_facets 1',
            f"--clean_niter {self.benchmark[self.size]['num_minor_cycles']}",
            '--clean_gain 0.1',  '--clean_psf_support 256',
            '--use_dask True',
            '--imaging_context ng',
            '--imaging_ng_threads $OMP_NUM_THREADS',
            f"--imaging_npixel {self.benchmark[self.size]['image']}",
            '--imaging_pol stokesI',
            '--clean_restored_output taylor', '--imaging_gaussian_taper 3e-5',
            '--imaging_cellsize 5e-6',
            '--imaging_weighting uniform', '--imaging_nchan 1',
            f"--ingest_vis_nchan {self.benchmark[self.size]['nfreq_chan']}",
            f"--ingest_chan_per_blockvis {self.benchmark[self.size]['nblock_vis']}",
            '--clean_component_threshold 0.1',
            '--clean_component_method fit',
            f'--ingest_msname ${{RESULTS_DIR}}/{DATASET_NAME}.ms',
            f'--logfile ${{RESULTS_DIR}}/{self.job.stdout}',
        ]

    @run_after('setup')
    def set_keep_files(self):
        """Set list of files that we want to keep in output folder"""
        nmoments = self.benchmark[self.size]['nmoment']
        self.keep_files = [
            f'{DATASET_NAME}_nmoment{nmoments}_cip_skymodel.hdf',
        ]
        self.keep_files += [
            f'{DATASET_NAME}_nmoment{nmoments}_cip.taylor.{im}.{t}.fits'
            for im in range(nmoments)
            for t in ['deconvolved', 'residual', 'restored']
        ]
        
    @run_after('setup')
    def rm_dask_worker_space(self):
        """Set RESULTS DIR env variable"""
        self.prerun_cmds += [
            'rm -rf $SCRATCH_DIR/dask-worker-space',
            # Increase file descriptors limit
            'ulimit -Sn 16384',
            'ulimit -Hn 65536',
        ]

    @run_before('run')
    def pre_launch(self):
        """Set pre run commands. It includes setting up dask cluster"""
        # Start schedulers and workers on all the nodes. Memory management and with nanny
        # processes
        self.prerun_cmds += [
            f'{self.dask_launcher_cmd} '
            f'dask-mpi --name=rascil-worker --nanny --interface=$NET_INTERFACE '
            f"--nthreads={self.dask_config['nthreads']} "
            '--memory-limit=0 --local-directory=$SCRATCH_DIR '
            '--scheduler-file=$SCHEDULER_FILE '
            '--scheduler-port=$SCHEDULER_PORT --dashboard-address=$DASHBOARD_PORT &',
            'sleep 20',
        ]
        # Set RASCIL dask scheduler env variable
        self.prerun_cmds += [
            'export RASCIL_DASK_SCHEDULER_FILE=${SCHEDULER_FILE}',
        ]

    @run_before('sanity')
    def set_sanity_patterns(self):
        """Set sanity patterns. When RASCIL finishes the job successfully, it creates image
        files in fits format. We check if the files are created as sanity check"""
        output_files = [
            sn.path_isfile(os.path.join(self.stagedir, f)) for f in self.keep_files
        ]
        # Check if all files are created
        self.sanity_patterns = sn.all(output_files)

    @performance_function('s')
    def extract_times(self, var='create_blockvisibility_from_ms'):
        """Generic performance extraction function to extract time"""
        if var not in ('create_blockvisibility_from_ms', 'skymodel_predict_calibrate',
                       'skymodel_calibrate_invert', 'imaging_deconvolve',
                       'imaging_grid_weights'):
            raise ValueError(f'illegal value in argument kind ({var!r})')

        return sn.extractall(
            rf'{var}\s*([\d\.]+)\s*([\d\.]+)\s*([\d]+)', self.stdout, 1, float
            )[0]

    @performance_function('s')
    def extract_wall_time(self):
        """Performance function to extract wall time. Sample output:

        .. code-block:: text

            # 26/07/2021 05:41:22 PM.110 rascil-logger INFO Started  : 2021-07-26 13:52:07.487374
            # 26/07/2021 05:41:22 PM.110 rascil-logger INFO Finished : 2021-07-26 17:41:22.110077

        """
        return self.convert_datestring_timestamp(sn.extractall(
            r'(.*) rascil-logger INFO Finished : (.*)', self.stdout, 2, None)[0], 'iso'
            ) - self.convert_datestring_timestamp(sn.extractall(
            r'(.*) rascil-logger INFO Started  : (.*)', self.stdout, 2, None)[0], 'iso'
            )

    @performance_function('s')
    def extract_imaging_time(self):
        """Performance extraction function for imaging time"""
        datetime_str = '%d/%m/%Y %I:%M:%S %p'
        return self.convert_datestring_timestamp(sn.extractall(
            r'(.*)\.(\d+) rascil-logger INFO Quality assessment:', self.stdout, 1, None)[0],
                                                 datetime_str
            ) - self.convert_datestring_timestamp(sn.extractall(
            r'(.*)\.(\d+) rascil-logger INFO deconvolve_list_singlefacet_rsexecute_workflow: '
            r'Starting clean', self.stdout, 1, None)[0], datetime_str
            )


    @performance_function('s')
    def extract_processing_time(self):
        """Performance extraction function for processing time. Sample output:

        .. code-block:: text

            # 27/07/2021 08:57:15 PM.171 rascil-logger INFO Total processor time 1102.612 (s), total wallclock time 161.490 (s),

        """
        return sn.extractall(
            r'(.*) rascil-logger INFO Total processor time ([\d\.]*) \(s\), (.*)', self.stdout,
            2, float
            )[0]

    @run_before('performance')
    def set_perf_variables(self):
        """Set performance variables"""
        self.perf_variables = {
            'Wall time': self.extract_wall_time(),
            'Total processing time': self.extract_processing_time(),
            'Imaging time': self.extract_imaging_time(),
            'Create block visibilities time': self.extract_times(),
            'Skymodel predict time': self.extract_times('skymodel_predict_calibrate'),
            'Skymodel invert time': self.extract_times('skymodel_calibrate_invert'),
            'Image deconvolution time': self.extract_times('imaging_deconvolve'),
            'Imaging grid weights time': self.extract_times('imaging_grid_weights'),
        }

    @run_before('performance')
    def set_reference_values(self):
        """Set reference perf values"""
        self.reference = {
            '*': {
                'Wall time': (None, None, None, 's'),
                'Total processing time': (None, None, None, 's'),
                'Imaging time': (None, None, None, 's'),
                'Create block visibilities time': (None, None, None, 's'),
                'Skymodel invert time': (None, None, None, 's'),
                'Skymodel predict time': (None, None, None, 's'),
                'Image deconvolution time': (None, None, None, 's'),
                'Imaging grid weights time': (None, None, None, 's'),
            }
        }
